/*
 * Project ReD
 * start.java -- centrale starter class
 * Copyright (C) Filip Pizlo 1997
 * This code is under GPL 2.0
 * You must read the README before proceeding!
 */

import java.net.*;
import java.io.*;

public class start {
 public static String lsep;
 public static Class gl;
 public static void main(String[] v) {
  try {
   lsep=System.getProperties().getProperty("line.separator");
   System.out.println("\nRedStart/0.1.4 Enabled\n(C)1997-1998 Filip Pizlo\nAll of Red (unless specified differently in individial modules) is GPL/2.0\nrun Red with -help for info; -license will show you GPL/2.0");
   boolean dl=true,chk=true,run=true;
   for (int i=0;i<v.length;i++) {
    if (v[i].equals("-help")||v[i].equals("--help")||v[i].equals("-?")||v[i].equals("-h")) {
     System.out.print("\n"+
      "Project Red Startup\n"+
      "start.class is made to check for upgrades to Red, and then start Red up. Here\n"+
      "are the possible params:\n"+
      "-help          Show this message\n"+
      "-checkonly     Only check for upgrades and notify user; don\'t download anything\n"+
      "-nocheck       Don\'t check or download upgrades\n"+
      "-norun         Do not start Red; just check/download upgrades\n"+
      "-license       View license; don't do anything else\n");
     return;
    } else if (v[i].equals("-checkonly")) dl=false;
    else if (v[i].equals("-nocheck")) chk=false;
    else if (v[i].equals("-norun")) run=false;
    else if (v[i].equals("-license")) {
     System.out.println("\nGPL/2.0 LICENSE:\n");
     BufferedReader fin=new BufferedReader(new InputStreamReader(new FileInputStream("LICENSE")));
     int cnt=0;
     while (true) {
      String tmp=fin.readLine();
      if (tmp==null) break;
      System.out.print(tmp+lsep);
      cnt++;
      if (cnt>15) {
       System.out.println("--MORE--");
       System.in.read();
       cnt=0;
      }
     }
     fin.close();
     return;
    } else System.out.println("Invalid param; consult -help");
   }
   goodload ld=new goodload();
   centbase cb=new dumbcent();
   ld=null;
   cb=null;
   if (chk) updatesafe(new URL(distro.SOURCEURL),dl);
   if (run) startup();
  } catch (Exception e) {
   System.err.println("\nRedStart error: "+e);
  }
 }
 public static void download(File local,URL ctx,String remote) throws Exception {
  FileOutputStream fout=new FileOutputStream(local);
  URL udl=new URL(ctx,remote);
  InputStream in=udl.openStream();
  byte data[]=new byte[65536];
  while (true) {
   int res=in.read(data,0,data.length);
   if (res<=0) break;
   fout.write(data,0,res);
  }
  fout.close();
  in.close();
 }
 public static void txtdownload(File local,URL ctx,String remote) throws Exception {
  PrintWriter fout=new PrintWriter(new FileOutputStream(local));
  URL udl=new URL(ctx,remote);
  BufferedReader fin=new BufferedReader(new InputStreamReader(udl.openStream()));
  while (true) {
   String tmp=fin.readLine();
   if (tmp==null) break;
   fout.print(tmp+lsep);
  }
  fout.close();
  fin.close();
 }
 public static void startup() throws Exception {
  goodload ld=new goodload("project.red",null);
  centbase some=(centbase)ld.loadClass("centrale",true).newInstance();
  some.init();
  some.servit();
 }
 public static void update(URL ctx,boolean dl) throws Exception {
  File vfl=new File("vernum");
  long lver=69l,rver=70l;
  try {
   DataInputStream fin=new DataInputStream(new FileInputStream(vfl));
   lver=fin.readLong();
   fin.close();
  } catch (Exception e) {}
  URL vur=new URL(ctx,"vernum");
  DataInputStream rin=new DataInputStream(vur.openStream());
  rver=rin.readLong();
  rin.close();
  if (rver>lver) {
   if (dl) {
    System.out.println("RedStart: Downloading...  (This might take some time)");
    start.download(new File("update.red"),ctx,"update.red");
    DataInputStream rfl=new DataInputStream(new FileInputStream("update.red"));
    long st,ln;
    st=rfl.readLong();
    ln=rfl.readLong();
    byte[] data=new byte[(int)st];
    rfl.read(data,0,data.length);
    updload ld=new updload();
    ld.putdata("redupd",data);
    data=new byte[(int)ln];
    rfl.read(data,0,data.length);
    rfl.close();
    Class c=ld.loadClass("redupd",true);
    updbase upd=(updbase)c.newInstance();
    System.out.println("RedStart: Running Red Upgrader...");
    try {
     upd.doit(data);
     System.out.println("RedStart: Done!  Be sure to read the README!");
    } catch (Throwable e) {
     System.out.println("RedStart Upgrade Error: "+e+"\nProceeding with caution...");
    }
    data=null;
    c=null;
    upd=null;
    ld=null;
/* deprecated as of 0.6
    start.download(new File("project.red"),ctx,"project.red");
    start.download(new File("source.zip"),ctx,"source.zip");
    start.download(new File("redstart.zip"),ctx,"redstart.zip");
    start.txtdownload(new File("README"),ctx,"README");
    start.txtdownload(new File("README.servlets"),ctx,"README.servlets");
    start.txtdownload(new File("LICENSE"),ctx,"LICENSE");
    DataOutputStream fout=new DataOutputStream(new FileOutputStream("vernum"));
    fout.writeLong(rver);
    fout.close();
end of depr */
   } else System.out.println("RedStart: Software needs upgrade!");
  }
 }
 static void updatesafe(URL ctx,boolean b) {
  try {
   update(ctx,b);
  } catch (Throwable e) {
   System.err.println("\nUpdate Error: "+e);
  }
 }
}

